## Planed Features

_This is a discussion-File, feel free to make a pull-request with suggestions_

### Improvements
- Use ES6 module-system
- Advance testing-strategy (there is still more potential)
- Implement Feature/UI-Tests
- Add some examples
- Fill README files in folders and link to the global README


### Features
**Implemented**
```javascript
// ## Define Command
both.command('Feed:Like', function(payload){
  // Update Feed-Entry e.g. mysql/mongo stuff
});
```


**Implemented**
```javascript
// ## Define Query
both.query('Feed:Likes', function(payload){
  // Find all likes in database an return those
});
```


**Implemented**
```javascript
// ## Execute Commands
both('Feed:Like', {}, function(){});
```


**Implemented**
```javascript
// ## Execute Queries
both('Feed:Likes', {}, function(){});
```


**Planed**
```javascript
// ## Execute command by clicking on the button - if successful, do some UI-Stuff
$('#createTodoButton').on('click', function(){
  both('CreateToDo', 'Clean your room')
  .on(function(){
    $(this).val('Todo Created!')
  });
});
```


**Planed**
```javascript
// ## Execute multiple Tasks

// # Idea A
both({
  'Todo:Create': {},
  'Notification:TodoCreated': {}
});

// # Idea B
both([
  'Todo:Create', () => {}
],[
  'Todo:UpdateCounter', () => {}
]);
```



**Planed**
```javascript
// ## Command Event-Listener
both.on('Feed', (payload) => {});
```


**Planed**
```javascript
// ## Command-Specific Event-Listener
both.on('Feed:Like', function(payload){});
```


**Implemented**
```javascript
// ## Global Event-Listener
both.on(function(payload){});
```


**Implemented**
```javascript
// ## Use middleware to simply use connectors
// Socket
both.use(io) // Frontend
both.use(socketio) // Backend
```


**Implemented**
```javascript
// ## Register whatever in global registery, so the modules can call it for registered commands/queries/listeners
both.register('command', {
  name: 'ExampleCommand',
  func: function(){ 'some function' }
});
```


**Planed**
## Execute methods from CLI
Defined Command:
```javascript
both.command('createToDo', function(name, args, callback){
  // args:
  // [0] Eat Pizza
  // [1] Tomorrow
  // [2] My Kitchen
});
```
Execute:
`$ both createToDo -args 'Eat Pizza, Tomorrow, My Kitchen'
