![BothIO Logo](http://docs.michaelzoidl.com/GithubLogoPaths.svg)

![](https://img.shields.io/badge/unicorn-approved-blue.svg)
[![Gratipay](http://img.shields.io/gratipay/michaelzoidl.svg)](https://gratipay.com/michaelzoidl/)
[![Build Status](https://travis-ci.org/michaelzoidl/both.io.svg?branch=master)](https://travis-ci.org/michaelzoidl/both.io)
[![bitHound Score](https://www.bithound.io/github/michaelzoidl/both.io/badges/score.svg)](https://www.bithound.io/github/michaelzoidl/both.io)
[![Codacy Badge](https://img.shields.io/codacy/98f77bcc84964e67a2754e563b962d27.svg)](https://www.codacy.com/app/me_1438/both-io)
[![devDependency Status](https://david-dm.org/michaelzoidl/both.io/dev-status.svg)](https://david-dm.org/michaelzoidl/both.io#info=devDependencies)

## What is BothIO?
Simply, it's a library based on the [CQS-Princip](http://en.wikipedia.org/wiki/Command%E2%80%93query_separation), where your methods are separated by **commands** and **queries**.<br><br>
What BothIO makes so special is the NodeJS/Client-Support, so you can execute your commands and queries from your node-side as well as from your client-side.

## Example
```javascript

var myToDoList = [];

// # Define a Command
// Server:
both.command('CreateTodo', function(name, payload, callback){
  myToDoList.push(payload.todoName);
});

// Execute a Command
// Client:
both('CreateTodo', {
  todoName: 'eat some chocolate'
});


// Listen to a defined Command
// Server:
both.on('CreateTodo', function(name, payload){
  console.log('Todo Created:', payload.todoName);
});

// Listen to all Commands
// Client:
both.on(function(commandName, payload){
  console.log('The command', commandName, 'was executed!');
  console.log('with the payload:', payload);
});


// # Add a Callback
// Server:
both.query('GetAllTodos', function(name, payload, callback){
  someDatabase.query('getAllTodos', function(todos){
    callback(todos);
  });
});

// Client:
both('GetAllTodos', {}, function(todos){
  // Use Todos at the client
})

```
[And there's something more planed](https://github.com/michaelzoidl/both.io/blob/master/PLANED.md)

## Battle-Tested
This project is used at the [entertain.io](https://github.com/michaelzoidl/entertain.io) platform.


## Contribute
BothIO uses the new ES6 standard and is tested with mocha, plus we package the code with webpack.
<br><br>
__You want contribute? Here is how you start:__<br>
_Clone repo_<br>
`git clone git@github.com:michaelzoidl/both.io.git`<br>
_Run the unit-tests_<br>
`npm run test`<br>
_Pack the code and save it in the dist-folder_<br>
`npm run pack`<br>
_Develop, it starts a mocha-watcher_<br>
`npm run develop`
