const command = (commandName, commandFn) => {

  let both = require('../both');

  // Error Handling
  if (commandName === undefined && commandFn === undefined) {
    throw new Error('[both] the `command` module expects a commandName and a commandFunction');
  }

  if (typeof commandName !== 'string') {
    throw new Error('[both] the `command` module expects a commandName as string');
  }

  if (commandFn === undefined) {
    throw new Error('[both] the `command` module expects a function as second argument');
  }

  if (typeof commandFn !== 'function') {
    throw new Error('[both] the `command` module expects a function as second argument');
  }

  both.register('command', {
    name: commandName,
    func: commandFn
  });

};

module.exports = command;
