const execute = (...args) => {

  let both      = require('../both');
  let methodName = args[0] || false;
  let methodOptional = args[1] || {};
  let methodCallback = args[2] || false;

  // Error Handling
  if (args.length === 0) {
    throw new Error('[both] to execute a command you should give us a identifier');
  }

  if (args.length > 3) {
    throw new Error('[both] the execute command doesnt permit more than two arguments');
  }

  if (typeof methodName !== 'string') {
    throw new Error('[both] to execute a command you should give us a string-identifier');
  }

  if (typeof methodOptional !== 'object') {
    throw new Error('[both] the second argument when you execute a command should always be a object or a');
  }

  if (typeof methodCallback !== 'function' && methodCallback !== false) {
    throw new Error('[both] to execute a command you should give us a function as callback');
  }

  // Execute commands
  if (both._globalRegistery.command && both._globalRegistery.command[methodName] !== undefined) {
    both._globalRegistery.command[methodName].func(methodName, methodOptional, methodCallback);
  }

  // Execute listeners
  if (both._globalRegistery.listener && both._globalRegistery.listener[methodName] !== undefined) {
    both._globalRegistery.listener[methodName].func(methodName, methodOptional, methodCallback);
  }

  // Execute queries
  if (both._globalRegistery.query && both._globalRegistery.query[methodName] !== undefined) {
    both._globalRegistery.query[methodName].func(methodName, methodOptional, methodCallback);
  }

  // Execute global listeners
  if (both._globalRegistery.listener) {
    Object.keys(both._globalRegistery.listener).forEach((listenerName) => {
      if (isNaN(listenerName) === false) {
        both._globalRegistery.listener[listenerName].func(methodName, methodOptional, methodCallback);
      }
    });
  }

};

module.exports = execute;
