const on = (...args) => {

  let both  = require('../both');
  let listeners = both.registery.listeners || {};

  // Error Handling
  if (args.length > 2) {
    throw new Error('[both] the `on` listener allow not more than two params');
  }

  if (args.length === 1 && typeof args[0] !== 'function') {
    throw new Error('[both] the `on` expects at least one function passed');
  }

  if (args.length === 0) {
    throw new Error('[both] the `on` expects some params, read the docs ;)');
  }

  // Module
  if (args.length === 1 && typeof args[0] === 'function') {

    let listenerID = 0;

    if (both._globalRegistery.listener) {
      listenerID = Object.keys(both._globalRegistery.listener).length === 0 ? 0 : Object.keys(listeners).length;
    }

    both.register('listener', {
      name: listenerID,
      func: args[0]
    });
  }

  if (args.length === 2 && typeof args[0] === 'string' && typeof args[1] === 'function') {
    let listenerID = args[0];

    both.register('listener', {
      name: listenerID,
      func: args[1]
    });
  }
};

module.exports = on;
