const query = (...args) => {

  let both      = require('../both');

  let queryName = null;
  let queryFn = null;

  if (args.length < 2) {
    throw new Error('[both] the `query` module expects a `queryName` and a `commandFunction`');
  } else {
    queryName = args[0];
    queryFn = args[1];
  }

  if (typeof queryName !== 'string') {
    throw new Error('[both] the `query` module expects a `queryName` in a string format');
  }

  if (typeof queryFn !== 'function') {
    throw new Error('[both] the `query` module expects the `queryFn` as function');
  }

  // Register function in Both-Registery
  both.register('query', {
    name: queryName,
    func: queryFn
  });

};

module.exports = query;
