let both    = require('../both');
let sinonChai = require('sinon-chai');
let sinon = require('sinon');
let chai    = require('chai');
chai.use(sinonChai);
let expect  = chai.expect;

describe('Query Module', () => {

  describe('Error handling', () => {

    it('throws error if less than 2 arguments are given', () => {
      expect(() => {
        both.query();
      }).to.throw(Error);
    });

    it('throws error if `queryName` is not a string', () => {
      expect(() => {
        both.query(123, sinon.spy());
      }).to.throw(Error);
    });

  });

  describe('Register queries', () => {

    let dummyQueryFunc = null;

    beforeEach(() => {
      dummyQueryFunc = sinon.spy();
      both.query('dummyQuery', dummyQueryFunc);
    });

    it('registers the query in the both-registery', () => {
      expect(both._globalRegistery.query.dummyQuery).to.deep.equal({
        name: 'dummyQuery',
        func: dummyQueryFunc
      });
    });
  });
});
