const use = (...args) => {

  let both = require('../both');

  // Register available middlewares
  let middlewareCollection = {
    'socket.io': {
      'server': require('./modules/socket.io/server'),
      'client': require('./modules/socket.io/client')
    }
  }

  let middlewareName = null;
  let middlewareUnit = null;
  let middlewareType = null;

  // Error handling
  if (args.length === 0) {
    throw new Error('[both] the `use` adapter expects two arguments [middlewareName, middleware]');
  }

  if (typeof args[0] !== 'string') {
    throw new Error('[both] the `use` adapter expects a [middlewareName]-String as first argument.');
  } else {
    middlewareName = args[0];
  }

  if (typeof args[1] === 'undefined') {
    throw new Error('[both] the `use` adapter expects a [middleware] as second argument');
  } else {
    middlewareUnit = args[1];
  }

  // Check if client or server
  if (typeof window !== 'undefined' && window) {
    middlewareType = 'client';
  } else {
    middlewareType = 'server';
  }

  if(middlewareCollection[middlewareName] !== undefined && middlewareCollection[middlewareName][middlewareType] !== undefined) {
    middlewareCollection[middlewareName][middlewareType](middlewareUnit);
  } else {
    throw new Error('[both] the `use` adapter didnt found any requested modules');
  }
};

module.exports = use;
